#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#pragma comment( lib, "../pdf2image.lib" )

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter(const char *szPDFFileName, const char *szOutputName,
								  const char *szUserPassword, const char *szOwnPassword,
								  int xresolution, int yresolution, int bitcount, 
								  int compression, int quality, BOOL grayscale, 
								  BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverterEx(const char *szPDFFileName, const char *szOutputName,
									const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									int xResORWidth, int yResORHeight, int bitcount, 
									int compression, int quality, int grayscale, 
									int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2(const char *szPDFFileName, const char *szOutputName,
								   const char *szUserPassword, const char *szOwnPassword,
								   int xresolution, int yresolution, int bitcount, 
								   int compression, int quality, BOOL grayscale, 
								   BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2Ex(const char *szPDFFileName, const char *szOutputName,
									 const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
									 int xResORWidth, int yResORHeight, int bitcount, 
									 int compression, int quality, int grayscale, 
									 int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetParameters(const char *parms);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageGetPageCount(const char *szPDFFileName);
extern "C" __declspec(dllexport)
HBITMAP __stdcall PDFToImageDrawToHDC(const char *szPDFFileName, HDC hDC, const char *szUserPassword, 
									  const char *szOwnPassword, int xresolution, int yresolution, 
									  int m_iBitCount, BOOL m_bGrayscale, int m_iPageIndex);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageBox(const char *inputPDFFile, int page, double *extent);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageWidth(const char *inputPDFFile, int page);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageHeight(const char *inputPDFFile, int page);
typedef int (__stdcall *PDFToImageProgressCBFunc)(void *, UINT Msg, WPARAM wParam, LPARAM lParam);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetProgressCBFunc(PDFToImageProgressCBFunc newFunc);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetFileNameSuffix(const char *ptrFileNameSuffix);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageEnableErrorDiffusion(BOOL bEnable);


extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetPageCount(char *inputTIFFFile);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno);
extern "C" __declspec(dllexport)
int __stdcall TIFFImageSetDPI(char *inputTIFFFile, int nXDPI, int nYDPI);
extern "C" __declspec(dllexport)
BOOL __stdcall TIFFImageAppendToMultipageTIFFFile(const char* srcImage,const char* destImage);


#define	COMPRESSION_NONE        1	/* dump mode */
#define	COMPRESSION_CCITTRLE    2	/* CCITT modified Huffman RLE */
#define	COMPRESSION_CCITTFAX3   3	/* CCITT Group 3 fax encoding */
#define	COMPRESSION_CCITTFAX4   4	/* CCITT Group 4 fax encoding */
#define	COMPRESSION_LZW         5       /* Lempel-Ziv  & Welch */
#define	COMPRESSION_JPEG        7	/* %JPEG DCT compression */
#define	COMPRESSION_PACKBITS    32773	/* Macintosh RLE */
#define	COMPRESSION_CLASSF      88888888
#define	COMPRESSION_CLASSF196   88888889
#define	COMPRESSION_CLASSF204X98_G3		88888886
#define	COMPRESSION_CLASSF204X196_G3	88888887
#define	COMPRESSION_CLASSF204X98_G4		88888888
#define	COMPRESSION_CLASSF204X196_G4             88888889
#define COMPRESSION_CLASSF_204X98_2048X1401_G4   88888890
#define	COMPRESSION_CLASSF_204X196_2048X2802_G4  88888891
#define	COMPRESSION_CLASSF_204X98_1620X1146_G4   88888892
#define COMPRESSION_CLASSF_204X98_1728X1143_G4   88888893
#define COMPRESSION_CLASSF_204X196_1728X2286_G4  88888894
#define COMPRESSION_CLASSF_204X98_1728X1074_G4   88888895


void main(int argc, char *argv[])
{
	if(argc != 2)
		return;

	char drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	char szPDFFileName[MAX_PATH];
	strcpy(szPDFFileName, argv[1]);

	char szTIFFFileName[MAX_PATH];
	_splitpath(szPDFFileName, drive, dir, fname, ext );
	_makepath(szTIFFFileName, drive, dir, fname, ".tif");

	PDFToImageSetCode("VPEDRFXY2PIDMFAGEXYUXEJHYEXNVERYPDF");

	int pagecount = PDFToImageGetPageCount(szPDFFileName);
	printf("Filename is: %s\n", szPDFFileName);
	printf("PageCount is: %d\n", pagecount);
	vector<string> vecTIFFFiles;
	for(int page = 1; page <= pagecount; page++)
	{
		int nPageWidth = PDFToImageGetPageWidth(szPDFFileName, page);
		int nPageHeight = PDFToImageGetPageHeight(szPDFFileName, page);
		printf("Page #%d, width = %d, height = %d\n", page, nPageWidth, nPageHeight);
		if(nPageWidth > nPageHeight)
		{
			nPageWidth = 2200;
			nPageHeight = 1701;
		}
		else
		{
			nPageWidth = 1701;
			nPageHeight = 2200;
		}
		
		int nResult = 0;
		_splitpath(szPDFFileName, drive, dir, fname, ext );
		char fname2[MAX_PATH];
		sprintf(fname2,"%s%04d",fname,page);
		char szOutFile[MAX_PATH];
		_makepath(szOutFile, drive, dir, fname2, ".tif");
		printf("OutFile = %s\n", szOutFile);

		int result = PDFToImageConverter2Ex(szPDFFileName, szOutFile, NULL,
			NULL, 1, nPageWidth, nPageHeight, 1, COMPRESSION_CCITTFAX4, 100,FALSE,TRUE, page, page);
		TIFFImageSetDPI(szOutFile, 200, 200);
		vecTIFFFiles.push_back(szOutFile);
	}
	for(int i = 0; i < vecTIFFFiles.size(); i++)
	{
		TIFFImageAppendToMultipageTIFFFile(vecTIFFFiles[i].c_str(), szTIFFFileName);
		DeleteFile(vecTIFFFiles[i].c_str());
	}
}